var Exedra = require('../../')
  , path = require('path')
  , join = path.join
  , express = require('express')
  , fructose = require('fructose')
  , vs = {}
  

// FIXME: move to another repo or find the appropriate analog
var notfound = require('./express-404')

var app = vs.app = express.createServer(
  express.logger(':method :status :url'),
  express.methodOverride(),
  express.cookieParser(),
  express.bodyParser(),
  express.favicon(join(__dirname, 'public', 'favicon.ico')),
  express.session({ secret: 'kbd cat' }),
  express.csrf(),
  express.limit('20mb')
)

app.set('path.routes', join(__dirname, 'routes'))
app.set('path.functions', join(__dirname, 'functions'))
app.set('path.views', join(__dirname, 'views'))
app.set('path.public', join(__dirname, 'public'))

app.set('views', app.set('path.views'))
app.register('.jade', require('jade'))
app.set('view engine', 'jade')
app.set('view options', { layout: 'layouts/default' })

app.set('showStackError', false)

app.configure('development', function(){
  app.set('showStackError', true)
  app.use(express.static(app.set('path.public')))
});

app.configure('staging', function(){

});

app.configure('production', function(){

});

vs.fructose = fructose

var exedra = new Exedra(vs)
exedra.functions().routes()

notfound(app, { layout: false })

app.listen(3000)



console.log()
app.routes.all().forEach(function(route){
  console.log('  \033[90m%s \033[36m%s\033[0m', route.method.toUpperCase(), route.path)
})
console.log()

console.log('  Printing variables list...\n')
for(var key in vs) {
  console.log('  \033[90m%s \033[31;2m%s\033[0m', key, (typeof vs[key]).toUpperCase())
}
console.log()
